package com.ff.weijinxiao.service;


import com.ff.weijinxiao.domain.MemberOrder;
import com.ff.weijinxiao.repository.MemberOrderRepository;
import com.ff.weijinxiao.util.SpecificationUtil;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import java.util.Optional;

@Service
public class MemberOrderService {

    @Resource
    private MemberOrderRepository memberOrderRepository;

    /**
     * 创建实体
     *
     * @param memberOrder
     */
    public MemberOrder saveMemberOrder(MemberOrder memberOrder) {
        return memberOrderRepository.save(memberOrder);
    }

    /**
     * 查找实体
     *
     * @param id
     * @return
     */
    public MemberOrder findById(Integer id) {
        Optional<MemberOrder> optional = memberOrderRepository.findById(id);
        if (optional.isPresent()) {
            return optional.get();
        } else {
            return null;
        }
    }

    public void deleteById(Integer id) {
        memberOrderRepository.deleteById(id);
    }

    /**
     * 分页条件查询
     *
     * @param page
     * @param size
     * @param param
     * @return
     */
    public Page<MemberOrder> findPage(int page, int size, Map<String, Object> param) {
        Sort.Direction direction = Sort.Direction.DESC;
        String sort = "id";
        Pageable pageable = new PageRequest(page - 1, size, direction, sort);
        return memberOrderRepository.findAll(SpecificationUtil.buildSpecification(param, MemberOrder.class), pageable);
    }

    /**
     * 根据条件查询List
     */
    public List<MemberOrder> findList(Map<String, Object> param) {
        return memberOrderRepository.findAll(SpecificationUtil.buildSpecification(param, MemberOrder.class));
    }


    public MemberOrder findByWechatSn(String wechatSn) {
        return memberOrderRepository.findByWechatSn(wechatSn);
    }
}
